;(function($){
	
	var PHP_EDITOR = null;
	
	$( document ).on( 'click', 'button', function(ev){ev.preventDefault();} );

	$( document ).on( 'click', '#save-settings', function(){
		$( '#loading-overlay' ).css( 'display', 'block' );
		var args = $( '#chart-settings' ).serialize();
		var nonce = $( '#settings-nonce' ).val();
		$.ajax({
			type: 'POST',
			url: ajaxurl,
			data: {
				action: 'rrj_save_settings',
				nonce: nonce,
				args: args,
			},
			success: function( resp, status, xhr ) {
				if ( 'undefined' != typeof resp.status && true === resp.status ) {
					document.location.reload();
				} else {
					$( '#loading-overlay' ).css( 'display', 'none' );
				}
			},
			error: function( req, status, err ){
				$( '#loading-overlay' ).css( 'display', 'none' );
			},
		});
	} );

	$( document ).on( 'click', '#reset-settings', function(){
		$( '#loading-overlay' ).css( 'display', 'block' );
		var nonce = $( '#settings-nonce' ).val();
		$.ajax({
			type: 'POST',
			url: ajaxurl,
			data: {
				action: 'rrj_reset_settings',
				nonce: nonce,
			},
			success: function( resp, status, xhr ){
				if ( 'undefined' != typeof resp.status && true === resp.status ) {
					document.location.reload();
				} else {
					$( '#loading-overlay' ).css( 'display', 'none' );
				}
			},
			error: function( req, status, err ){
				$( '#loading-overlay' ).css( 'display', 'none' );
			},
		});

	} );

	$( document ).on( 'click', '.nav-tab', function(){
		if ( $( this ).hasClass( 'nav-tab-active' ) ) return;
		var target = $( this ).attr( 'href' );
		$( '.nav-tab' ).removeClass( 'nav-tab-active' );
		$( '.nav-tab-div' ).css( 'display', 'none' );
		$( this ).addClass( 'nav-tab-active' );
		$( target ).css( 'display', 'block' );
	} );

	$( document ).on( 'click', '#new-function', function(){
		var fn = $( '#new-function-name' ).val().trim();
		if ( !fn ) {
			$( '#new-function-name' ).css( 'border-color', '#ff5722' );
		} else {
			$( '#new-function-name' ).val( '' );
			$( '#new-function-name' ).css( 'border-color', '#ddd' );
			$( '#loading-overlay' ).css( 'display', 'block' );
			var nonce = $( '#settings-nonce' ).val();
			$.ajax({
				type: 'POST',
				url: ajaxurl,
				data: {
					action: 'rrj_new_fn',
					nonce: nonce,
					fn: fn,
				},
				success: function( resp, status, xhr ){
					$( '#loading-overlay' ).css( 'display', 'none' );
					if ( 'undefined' != typeof resp.status && true === resp.status && resp.functions ) {
						rrjPhpFunctions = resp.functions;
						$( '#function-selector, #testee-selector' ).append( '<option value="' + fn + '">' + fn + '</option>' ).val( fn );
						$( '#function-selector' ).trigger( 'change' );
					}
				},
				error: function( req, status, err ){
					$( '#loading-overlay' ).css( 'display', 'none' );
				},
			});
		}
	} );

	$( document ).on( 'change', '#function-selector', function(){
		var fn = $( this ).val();
		if ( fn ) {
			$( '#function-editor' ).css( 'display', 'block' );
			$( '#function-editor [name="function-name"]' ).val( 'fn' );
			$( '#function-editor [name="function-storage"]' ).val( rrjPhpFunctions[fn]['storage'] );
			if ( null === PHP_EDITOR ) {
				var input = $( '#function-editor [name="function-code"]' );
				PHP_EDITOR = CodeMirror(function(el){
					input.hide().after( $(el) );
				},{
					mode: 'php',
					startOpen: true,
					lineNumbers: true,
				});
                PHP_EDITOR.on( 'changes', function( editor, changes ) {
                    $( '#execute-test' ).prop( 'disabled', true );
                } );
			}
			var doc = PHP_EDITOR.getDoc();
            var code = "<?php\n";
            
            if ( 'undefined' != typeof rrjPhpFiles[fn] ) {
                code = rrjPhpFiles[ fn ];
            // } else if ( 'undefined' != typeof rrjPhpFunctions[fn]['code'] ) {
                // code = rrjPhpFunctions[fn]['code'];
            } else {
                code = '';
            }
            
			doc.setValue( code );
			PHP_EDITOR.refresh();
			$( '#response-div > div' ).empty();
			$( '#response-div' ).css( 'display', 'none' );
            $( '#execute-test' ).prop( 'disabled', false );
		}
	} );

	$( document ).on( 'click', '#save-function', function(){
		$( '#loading-overlay' ).css( 'display', 'block' );
		var doc = PHP_EDITOR.getDoc();
		var fn = $( '#function-selector' ).val();
		var storage = $( '#storage' ).val();
		var nonce = $( '#settings-nonce' ).val();
		$.ajax({
			type: 'POST',
			url: ajaxurl,
			data: {
				action: 'rrj_save_function',
				'rrj-settings-nonce': nonce,
				fn: fn,
				storage: storage,
				code: doc.getValue(),
			},
			success: function( resp, status, xhr ){
                if ( resp.status ) {
                    $( '#rrj-rfc' ).empty();
                    $( '#loading-overlay' ).css( 'display', 'none' );
                    $( '#execute-test' ).prop( 'disabled', false );
                } else if ( resp.form ) {
                    $( '#rrj-rfc' ).html( resp.form ).css( 'display', 'block' );
                    $( '#rrj-rfc form' ).on( 'submit', function( ev ){
                        ev.preventDefault();
                        rfcSubmitCreds();
                    } );
                }
			},
			error: function( req, status, err ){
				$( '#loading-overlay' ).css( 'display', 'none' );
			},
		});
	} );
	
    $( document ).on( 'rfcFileModified', function( ev, params ){
        if ( 'saveFunction' == params.action ) {
            $( '#loading-overlay' ).css( 'display', 'none' );
            if ( params.fileContent && PHP_EDITOR ) {
                var doc = PHP_EDITOR.getDoc();
                doc.setValue( params.fileContent );
                PHP_EDITOR.refresh();
                $( '#execute-test' ).prop( 'disabled', false );
            }
        }
        if ( 'deleteFunction' == params.action || 'upgradeFunctions' == params.action ) {
            document.location.reload();
        }
    } );
    
    $( document ).on( 'click', '#endError .notice-dismiss', function ( ev ) {
        $( this ).closest( '#endError' ).remove();
    } );
    
    $( document ).on( 'rfcEndError', function( ev, params ) {
        $( '#loading-overlay' ).css( 'display', 'none' );
        if ( 'undefined' != typeof params.endError ) {
            $( '#endError' ).remove();
            var notice = $( '#end-error-notice' ).html();
            var $notice = $( notice );
            $notice.find( 'p' ).html( params.endError );
            $( '#php-functions-div' ).prepend( $notice );
        }
    } );
    
    $( document ).on( 'click', '#rrj-rfc .cancel-button', function(ev) {
        $( '#rrj-rfc' ).css( 'display', 'none' );
        $( '#loading-overlay' ).css( 'display', 'none' );
    } );
    
	$( document ).on( 'click', '#delete-function', function(){
		$( '#loading-overlay' ).css( 'display', 'block' );
		var fn = $( '#function-selector' ).val();
		var nonce = $( '#settings-nonce' ).val();
		$.ajax({
			type: 'POST',
			url: ajaxurl,
			data: {
				action: 'rrj_delete_function',
				'rrj-settings-nonce': nonce,
				fn: fn,
			},
			success: function( response, status, xhr ){
                if ( response.status ) {
                    document.location.reload();
                } else if ( response.form ) {
                    $( '#rrj-rfc' ).html( response.form ).css( 'display', 'block' );
                    $( '#rrj-rfc form' ).on( 'submit', function( ev ){
                        ev.preventDefault();
                        rfcSubmitCreds();
                    } );
                }
			},
			error: function( req, status, err ){
				$( '#loading-overlay' ).css( 'display', 'none' );
			},
		});
	} );
	
	$( document ).on( 'click', '#execute-test', function( ev ) {
		ev.preventDefault();
		$( '#loading-overlay' ).css( 'display', 'block' );
		var conds = {};
		$( '.condlabel .conditional' ).each(function(){
			conds[$(this).attr( 'data-fn' )] = $( this ).prop( 'checked' );
		});
		
        var fn = $( '#function-selector' ).val();
        
		$.ajax({
			type: 'post',
			url: ajaxurl,
			data: {
				nonce: $( '#settings-nonce' ).val(),
				action: 'rrj_test_fn',
				fn: fn,
				conditionals: JSON.stringify( conds, '', false ),
			},
			success: function( resp, status, xhr ){
				$( '#loading-overlay' ).css( 'display', 'none' );
				$( '#response-div' ).css( 'display', 'block' );
				try {
					var respObj = JSON.parse( resp );
				} catch ( E ) {};
				if ( 'undefined' != typeof respObj ) {
					var respTxt = JSON.stringify( respObj, '', 2 );
					$( '#response-div > div' ).html( '<pre>' + respTxt + '</pre>' );
				} else {
					$( '#response-div > div' ).html( '<p>' + rrjAcI18n.unknownResponse.replace( '%s', resp ) + '</p>' );
				}
			},
			error: function( req, status, err ){
				$( '#loading-overlay' ).css( 'display', 'none' );
				$( '#response-div' ).css( 'display', 'block' );
				$( '#response-div > div' ).html( '<code>' + req.status + ': ' + err + '</code>' );
			},
		});
		
	} );
	
	$( document ).on( 'click', '#show-conditionals', function(){
		$( '#conditionals' ).css( 'display', 'block' );
		$( this ).css( 'display', 'none' );
	} );
	
    $( document ).on( 'click', '#upgrade-functions', function ( ev ) {
		$( '#loading-overlay' ).css( 'display', 'block' );
		$.ajax({
			type: 'post',
			url: ajaxurl,
			data: {
				'rrj-settings-nonce': $( '#settings-nonce' ).val(),
				action: 'rrj_upgrade_fn',
			},
			success: function( response, status, xhr ){
                if ( response.status ) {
                    document.location.reload();
                } else if ( response.form ) {
                    $( '#rrj-rfc' ).html( response.form ).css( 'display', 'block' );
                    $( '#rrj-rfc form' ).on( 'submit', function( ev ){
                        ev.preventDefault();
                        rfcSubmitCreds();
                    } );
                }
			},
			error: function( req, status, err ){
				$( '#loading-overlay' ).css( 'display', 'none' );
			},
		});
		
    } );
    
	$(function(){
		$( '.color-input' ).wpColorPicker();
		if ( document.location.hash ) {
			$( '.nav-tab[href="' + document.location.hash + '"]' ).trigger( 'click' );
		} else {
			$( '.nav-tab' ).first().trigger( 'click' );
		}
	})

})(window.jQuery);