;(function($){
    
    "use strict";
    
    window.rfcSubmitCreds = function() {

        $( '#rfc-wrap .overlay' ).css( 'display', 'block' );
        var str = $( '#rfc-wrap form' ).serialize().replace( /\+/g,'%20' );

        var params = str.split( '&' );
        var url = $( '#rfc-wrap form' ).attr( 'action' );
        var args = {};
        for ( var i in params ) {
            var param = params[i].split( '=' );
            args[ param[0] ] = decodeURIComponent( param[1] );
        }
        
        $.ajax({
            url: url,
            type: 'POST',
            data: args,
            success: function( response, status, XHR ){
                if ( true === response.status ) {
                    $( '#rfc-wrap .overlay' ).css( 'display', 'none' );
                    $( '#rfc-wrap' ).remove();
                    $( 'body' ).trigger( 'rfcFileModified', [ response ] );
                } else {
                    if ( response.form ) {
                        $( '#rfc-wrap' ).replaceWith( $( response.form ) );
                        $( '#rfc-wrap form' ).on( 'submit', function( ev ) {
                            ev.preventDefault();
                            rfcSubmitCreds();
                        } );
                    } else if ( response.endError ) {
                        $( '#rfc-wrap .overlay' ).css( 'display', 'none' );
                        $( '#rfc-wrap' ).remove();
                        $( 'body' ).trigger( 'rfcEndError', [ response ] );
                    }
                }
            },
            error: function( request, status, error ) {
                
            },
        });
        
    }
    
})(window.jQuery);